PrefabFiles = {
--    "ant",
--	"anthive",
--	"anthill",
	"rat",
	"rathole"
}

local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TUNING = GLOBAL.TUNING
local ACTIONS = GLOBAL.ACTIONS
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TECH = GLOBAL.TECH
local STRINGS = GLOBAL.STRINGS
local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
local require = GLOBAL.require
local GetWorld = GLOBAL.GetWorld
local GetClock = GLOBAL.GetClock
local GetPlayer = GLOBAL.GetPlayer
local SpawnPrefab = GLOBAL.SpawnPrefab
local Vector3 = GLOBAL.Vector3
local FindWalkableOffset = GLOBAL.FindWalkableOffset



Assets = 
{
	Asset("ATLAS", "images/inventoryimages/rat.xml"),


}


TUNING.RAT_SPAWN_RATE = GetModConfigData("Ammount")



TUNING.ANT_HEALTH = 35
TUNING.ANT_DAMAGE = 3
TUNING.ANT_SPEED = 3


STRINGS.NAMES.RAT = "Rat"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.RAT = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.RAT.GENERIC = "Stay away of may food, dirty rat!"
STRINGS.CHARACTERS.WILLOW.DESCRIBE.RAT = {}
STRINGS.CHARACTERS.WILLOW.DESCRIBE.RAT.GENERIC = "The rat is real!"
STRINGS.CHARACTERS.WENDY.DESCRIBE.RAT = {}
STRINGS.CHARACTERS.WENDY.DESCRIBE.RAT.GENERIC = "Rat comes... to all."


STRINGS.NAMES.RABBITHOLE = "Hole"


STRINGS.NAMES.RATHOLE = "Hole"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.RATHOLE = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.RATHOLE.GENERIC = "Someone lives here."
STRINGS.CHARACTERS.WILLOW.DESCRIBE.RATHOLE = {}
STRINGS.CHARACTERS.WILLOW.DESCRIBE.RATHOLE.GENERIC = "Go out dirty rat!"
STRINGS.CHARACTERS.WENDY.DESCRIBE.RAT = {}
STRINGS.CHARACTERS.WENDY.DESCRIBE.RAT.GENERIC = "I wish I could hide."


-----treasurechest

local function onsave(inst, data)
	if inst.components.container and inst.grz and inst.grz==true then
		data.grz = true
	end

end

local function onload(inst, data)
	if inst.components.container and data and data.grz and data.grz==true then
		print("breaking chest")
		inst.grz = true
		inst.AnimState:SetMultColour(0.45,.45,.45,1)
	end

end


local function ratTPpoint(pt)
    local theta = math.random() * 2 * 3.14
    local radius = 17

	local offset = FindWalkableOffset(pt, theta, radius, 12, true)
	if offset then
		return pt+offset
	end
end


local function ratteleport()
	local player = GetPlayer()
	local tp = SpawnPrefab("rathole")
	
	local pt = Vector3(GetPlayer().Transform:GetWorldPosition())
	
	local spawn_pt = ratTPpoint(pt)
		tp.Transform:SetPosition(spawn_pt:Get() )
print("=========SPAWN RAT !!!========")
end

local function ratspawnchance(inst)
print("SPAWN RAT chance!!!")

 	local day = GetClock().numcycles
	local rats_chance = (day*0.006+0.03)*TUNING.RAT_SPAWN_RATE
	print("rats  "..rats_chance)
	
	if rats_chance >0.8*TUNING.RAT_SPAWN_RATE then rats_chance = 0.8*TUNING.RAT_SPAWN_RATE end

	if math.random()<rats_chance then
		print("chance procs")
		ratteleport()
		if math.random()<rats_chance*0.6*TUNING.RAT_SPAWN_RATE and day>45/TUNING.RAT_SPAWN_RATE then
			print("chance procs double rat")
			ratteleport()
			
			if math.random()<rats_chance*0.4*TUNING.RAT_SPAWN_RATE and day>70/TUNING.RAT_SPAWN_RATE then
				print("chance procs TRIPLE rat")
				ratteleport()
			end
		end
	end
end



AddPrefabPostInit("world", function(inst)
	GLOBAL.assert( GLOBAL.GetPlayer() == nil )
	local player_prefab = GLOBAL.SaveGameIndex:GetSlotCharacter()

	GLOBAL.TheSim:LoadPrefabs( {player_prefab} )
	local oldfn = GLOBAL.Prefabs[player_prefab].fn
	GLOBAL.Prefabs[player_prefab].fn = function()
		local inst = oldfn()
		inst:ListenForEvent( "nighttime", function() ratspawnchance(inst) end, GetWorld())
		return inst
	end
end)

local function treasurechestupdate(prefab)
	local inst=prefab

	inst.OnSave = onsave
    inst.OnLoad = onload
		inst:DoPeriodicTask(math.random(20,40), function()
			if inst.components.container and inst.grz and inst.grz==true then
				print("drop item?")
				local rand = inst.components.container:GetItemInSlot(math.random(1,9))
				if rand then
					inst.components.container:DropItem(rand)
				end
				
			end
		end)
		
		local function onrepaired(inst)
		
			inst.AnimState:PlayAnimation("open") 
			inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")

		 if inst.grz == true and inst.components.container:Has("boards", 1) then
			local chest = inst
			inst.components.container:ConsumeByName("boards",1)
			chest.AnimState:PlayAnimation("close")
			chest.AnimState:SetMultColour(1,1,1,1)
			SpawnPrefab("collapse_small").Transform:SetPosition(chest.Transform:GetWorldPosition())
			chest.grz = false
			local words = {"I repaired this chest.","Very good, it's ok now.","Fixed!","Repaired!","Fine now.","Ready for use."}
			local word = words[math.random(#words)]
			GetPlayer().components.talker:Say(word, 3, false)

			end
		end


	inst.components.container.onopenfn = onrepaired
		
		
		
	
end


AddPrefabPostInit("treasurechest", treasurechestupdate)

